package net.minecraft.server;

import java.util.Iterator;

public class ItemTool extends Tool {
	
    public EnumToolMaterial a;

    protected ItemTool(int i, int j, EnumToolMaterial enumtoolmaterial, Block[] ablock) {
        super(false, null, i, enumtoolmaterial.a(), j + enumtoolmaterial.c(), getToolPower(enumtoolmaterial), enumtoolmaterial.b());
        this.a = enumtoolmaterial;
        toolBase = getToolBase();
        for (int k = 0; k < ablock.length; k++)
        	mineBlocks.add(new BlockHarvestPower(ablock[k].id, 0.0F));
    }
    
    public ToolBase getToolBase() {
        if(this instanceof ItemPickaxe)
            return ToolBase.Pickaxe;
        if(this instanceof ItemAxe)
            return ToolBase.Axe;
        if(this instanceof ItemSpade)
            return ToolBase.Shovel;
        else
            return null;
    }

    public static float getToolPower(EnumToolMaterial material) {
        if(material == EnumToolMaterial.DIAMOND)
            return 80F;
        if(material == EnumToolMaterial.IRON)
            return 60F;
        return material != EnumToolMaterial.STONE ? 20F : 40F;
    }
    
    public boolean canHarvest(Block block) {
        if(!usingSAPI && !isBlockOnList(block.id)) {
            if(this instanceof ItemPickaxe) {
                if(id <= 369)
                    return false;
                if(block.material == Material.STONE || block.material == Material.ICE)
                    return true;
                if(block.material == Material.ORE && basePower >= 40F)
                    return true;
            } else if(this instanceof ItemAxe) {
                if(id <= 369)
                    return false;
                if(block.material == Material.WOOD || block.material == Material.LEAVES || block.material == Material.PLANT || block.material == Material.CACTUS || block.material == Material.PUMPKIN)
                    return true;
            } else if(this instanceof ItemSpade) {
                if(id <= 369)
                    return false;
                if(block.material == Material.GRASS || block.material == Material.EARTH || block.material == Material.SAND || block.material == Material.SNOW_LAYER || block.material == Material.SNOW_BLOCK || block.material == Material.CLAY)
                    return true;
            }
        }
        return super.canHarvest(block);
    }

    private boolean isBlockOnList(int blockID) {
        for(Iterator<BlockHarvestPower> iterator = mineBlocks.iterator(); iterator.hasNext();) {
            BlockHarvestPower power = (BlockHarvestPower)iterator.next();
            if(power.blockID == blockID)
                return true;
        }
        for(Iterator<BlockHarvestPower> iterator1 = toolBase.mineBlocks.iterator(); iterator1.hasNext();) {
            BlockHarvestPower power = (BlockHarvestPower)iterator1.next();
            if(power.blockID == blockID)
                return true;
        }
        return false;
    }
}
