package net.minecraft.server;

import java.util.*;

public class ToolBase {

    public ToolBase() {
        mineBlocks = new ArrayList<BlockHarvestPower>();
        mineMaterials = new ArrayList<Material>();
    }

    public boolean canHarvest(Block block, float currentPower) {
        for(Iterator<Material> iterator = mineMaterials.iterator(); iterator.hasNext();) {
            Material material = iterator.next();
            if(material == block.material)
                return true;
        }
        for(Iterator<BlockHarvestPower> iterator1 = mineBlocks.iterator(); iterator1.hasNext();) {
            BlockHarvestPower power = iterator1.next();
            if(block.id == power.blockID || currentPower >= power.percentage)
                return true;
        }
        return false;
    }

    public static final ToolBase Pickaxe;
    public static final ToolBase Shovel;
    public static final ToolBase Axe;
    public ArrayList<BlockHarvestPower> mineBlocks;
    public ArrayList<Material> mineMaterials;

    static {
        SAPI.showText();
        Pickaxe = new ToolBase();
        Shovel = new ToolBase();
        Axe = new ToolBase();
        List<Integer> list = Arrays.asList(new Integer[] {
            1, 4, 16, 21, 22, 23, 24, 43, 44, 45, 
            48, 52, 61, 62, 67, 77, 79, 87, 89, 93, 
            94
        });
        int blockID;
        for(Iterator<Integer> iterator = list.iterator(); iterator.hasNext(); Pickaxe.mineBlocks.add(new BlockHarvestPower(blockID, 20F)))
            blockID = iterator.next();
        list = Arrays.asList(new Integer[] {
            15, 42, 71
        });
        for(Iterator<Integer> iterator1 = list.iterator(); iterator1.hasNext(); Pickaxe.mineBlocks.add(new BlockHarvestPower(blockID, 40F)))
            blockID = iterator1.next();
        list = Arrays.asList(new Integer[] {
            14, 41, 56, 57, 73, 74
        });
        for(Iterator<Integer> iterator2 = list.iterator(); iterator2.hasNext(); Pickaxe.mineBlocks.add(new BlockHarvestPower(blockID, 60F)))
            blockID = iterator2.next();
        list = Arrays.asList(new Integer[] {
            49
        });
        for(Iterator<Integer> iterator3 = list.iterator(); iterator3.hasNext(); Pickaxe.mineBlocks.add(new BlockHarvestPower(blockID, 80F)))
            blockID = iterator3.next();
        list = Arrays.asList(new Integer[] {
            2, 3, 12, 13, 78, 80, 82
        });
        for(Iterator<Integer> iterator4 = list.iterator(); iterator4.hasNext(); Shovel.mineBlocks.add(new BlockHarvestPower(blockID, 20F)))
            blockID = iterator4.next();
        list = Arrays.asList(new Integer[] {
            5, 17, 18, 25, 47, 53, 54, 58, 63, 64, 
            65, 66, 68, 69, 81, 84, 85
        });
        for(Iterator<Integer> iterator5 = list.iterator(); iterator5.hasNext(); Axe.mineBlocks.add(new BlockHarvestPower(blockID, 20F)))
            blockID = iterator5.next();
    }
}
