package net.minecraft.server.overrideapi;

import java.lang.reflect.Field;
import java.util.logging.Logger;

import net.minecraft.server.Block;
import net.minecraft.server.Item;
import net.minecraft.server.MinecraftServer;
import net.minecraft.server.ThreadServerApplication;
import net.minecraft.server.overrideapi.utils.Reflection;

public class OverrideAPI {
    
    /**
     * This method can override vanilla blocks, like grass, stone, obsidian, etc, with your ones.
     * First parameter - target block, e.g Block.stone; Second parameter - your Block class.
     * REMEMBER, if you have parameters in constructor of your Block class, this will crash.
     * 
     * @param target
     * @param override
     * @return
     */
    public static Block overrideVanillaBlock(Block target, Class<? extends Block> override) {
        try {
            Block.byId[target.id] = null;
            Block overrideInst = override.newInstance();
            for (int i = 0; i < Block.class.getDeclaredFields().length; i++) {
                try {
                    if (((Block)Block.class.getDeclaredFields()[i].get(null)).equals(target)) {
                        Field field = Block.class.getDeclaredFields()[i];
                        Reflection.publicField(field);
                        field.set(null, overrideInst);
                        break;
                    }
                } catch (Exception e) {}
            }
            for (Item item : Item.byId)
                try {
                    Field blocksEffectiveAgainstField = Reflection.publicField(Reflection.findField(target.getClass(), "bk"));
                    Block[] blocksEffectiveAgainst = (Block[]) blocksEffectiveAgainstField.get(item);
                    for (int i = 0; i < blocksEffectiveAgainst.length; i++)
                        if (blocksEffectiveAgainst[i].equals(target)) {
                            blocksEffectiveAgainst[i] = overrideInst;
                            blocksEffectiveAgainstField.set(item, blocksEffectiveAgainst);
                            break;
                        }
                } catch (Exception e) {}
            System.gc();
            LOGGER.info("Overrided " + target.l());
            return overrideInst;
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
    /**
     * Returns current thread's Minecraft instance
     * 
     * @return
     */
    public static MinecraftServer getMinecraftInstance() {
        if(MinecraftInstance == null)
            try {
                ThreadGroup threadgroup = Thread.currentThread().getThreadGroup();
                int i = threadgroup.activeCount();
                Thread athread[] = new Thread[i];
                threadgroup.enumerate(athread);
                int j = 0;
                do {
                    if(j >= athread.length)
                        break;
                    if(athread[j].getName().equals("Server thread")) {
                        MinecraftInstance = (MinecraftServer) Reflection.publicField(Reflection.findField(ThreadServerApplication.class, "a")).get(athread[j]);
                        break;
                    }
                    j++;
                } while(true);
            }
            catch(Exception exception) {
                exception.printStackTrace();
            }
        return MinecraftInstance;
    }
    
    private OverrideAPI() {}
    public final static Logger LOGGER = Logger.getLogger("Override API");
    private static MinecraftServer MinecraftInstance;
    public static final OverrideAPI INSTANCE = new OverrideAPI();
}